from ngsolve import *
from netgen.csg import *
import math

b1 = OrthoBrick(Pnt(-2,-2,-2), Pnt(2,2,2)).bc("outerbound")
b2 = OrthoBrick(Pnt(-1,-1,-1), Pnt(1,1,1)).bc("interface")

geo = CSGeometry()
geo.Add (  (b1-b2).mat("outer") )
geo.Add ( b2.mat("inner") )

mesh = Mesh(geo.GenerateMesh(maxh=0.4))

print (mesh.GetMaterials())
print (mesh.GetBoundaries())

fes0 = L2(mesh, order=2, definedon=mesh.Materials("inner"))
gf0 = GridFunction(fes0)
gf0.Set (sin(math.pi*x))

Draw (gf0, mesh, "gf0")


fes1 = FacetFESpace(mesh, order=2, definedon=mesh.Materials("outer"))
gf1 = GridFunction(fes1)

gf1.Set (BoundaryFromVolumeCF(gf0), definedon=mesh.Boundaries("interface"))

Draw (gf1, mesh, "gamma", draw_vol=False)




print (Integrate (9*x**8*dx(definedon="inner", bonus_intorder=10), mesh))
